/*
  classid.h
  ------------------------------------------------------------------------
  This file defines an Id for every class derived from cAbsTree.
  If you derive a class from cAbsTree, you MUST define an Id
  here.
  
  ------------------------------------------------------------------------
  @(#) $Id: classid.h,v 1.9 1996/08/27 19:26:49 emery Exp $
  ------------------------------------------------------------------------
  AUTHOR/CONTACT:
 
  Emery Berger                    | <http://www.cs.utexas.edu/users/emery>
  Systems Analyst                 @           <mailto:emery@cs.utexas.edu>
  Parallel Programming Group      |  <http://www.cs.utexas.edu/users/code>
  Department of Computer Sciences |             <http://www.cs.utexas.edu>
  University of Texas at Austin   |                <http://www.utexas.edu>
  ========================================================================
*/

#ifndef _classid_x
#define _classid_x

              // Don't erase this = 1, GetContaining needs it.
enum ClassId {Program = 1, Graph, Expr, OrOp, IntConst, RealConst, Ident,
		AndOp, NEOp, EqOp, GEOp, LEOp, LTOp, GTOp, MinusOp,
		PlusOp, ModOp, DivOp, MultOp, SelectOp, NotOp,
	        UnaryMinusOp, ArrayIndOp, FuncCallOp, Gather,
	        FuncArgSpec, FuncSig, Arc, PartArc, MergeArc, ExpandArc, 
                ContractArc, Strip_UpdateArc, AlignArc, StructType, ArrayType,
                TypeDef, StructMem, NSRel, PortSpec, NSPortSpec, UC,
	        NamedType, CallStmt, WhileStmt, BlockStmt, IfStmt, AssignStmt,
                NullStmt, MemSize, VarDecl, NewExpr, ReplSpec,
		Guard, Binding, Rule, ArcInput, ArcOutput, PortSType,
	        IntNode, CallNode, CrepNode, IntSType, RealSType, SymTab,
	        CharSType, ArraySType, StructMemSType, StructSType,
	        SEFuncArg, SEFuncName, SEVariable, SEAuxStructInfo,
                SEAuxStructMember, SETypeName, SEPortName,
	        SEIntNode, SESharedVar, SECreP, SEGraph, SizeSpec};

#endif
