#include <config.h>
// This file contains methods for non-UC node related
// abstract syntax tree classes.

#include <stddef.h>
#include <stream.h>
#include "../misc/general.h"
#include "classid.h"
#include "object.h"
#include "abstree.h"
#include "exmodel.h"

cIntNode::cIntNode()
{

   if (DebugLevel >= 7) {
      cout << "cIntNode created\n";
   }
}


cIntNode::~cIntNode()
{
}


void cIntNode::List()
{
   cout << "Interface_Node " << Name << " <" << UID << "> {\n"
        << "   Type is " << Type << "\n"
        << "   Is Input = " << InParam << "\n"
        << "}\n\n";
}


cCrepNode::cCrepNode()
{

   if (DebugLevel >= 7) {
      cout << "cCrepNode created\n";
   }
}


cCrepNode::~cCrepNode()
{
}


void cCrepNode::List()
{
   cout << "Creation_Param_Node " << " <" << UID << "> {\n"
        << "   Type = " << Type << "\n"
        << "}\n\n";
}


cCallNode::cCallNode()
{

   if (DebugLevel >= 7) {
      cout << "cCallNode created\n";
   }
}


cCallNode::~cCallNode()
{
}


void cCallNode::List()
{
   cout << "Call_Node " << Name << " <" << UID << "> {\n"
        << "   CalledGraph = " << CalledGraph << "\n"
        << "}\n\n";
}
