#ifndef _MsgUI_x
#define _MsgUI_x

#include <stdio.h>

// Message Display Routines

// These routines are used to display messages to the user.   Routine
// YYUIMessage is used to post messages for display.  It has exactly
// the same arguments and interface as printf.  The idea is that you
// can call YYUIMessage any number of times to post messages for display.
// To get them to appear, call YYUIMessageDisplay.  In this way,
// several messages can be collected and then presented to the user
// all togther.  To Display just one message, call YYUIMessage
// followed by YYUIMessageDisplay.

// extern char *UIMessages[];    // This should be deleted

enum MsgLevel {FatalLevel, ErrorLevel, WarningLevel, NoteLevel};

extern void YYUIMessage(int uid, MsgLevel Level, char *format_string, ...);
extern void YYUIMessage(MsgLevel Level, char *format_string, ...);
extern void YYUIMessageDisplay();

extern FILE *ErrorLogFile;

#endif
