#ifndef _C2_ADDRMAP_
#define _C2_ADDRMAP_

#include "c2_forward.h"
#include "c2_misc.h"

     /* Get address of UID from given graph */

void *_c2_GetAddr(/* _c2_GraphBase *Graph; int UID; _c2_Index *Index; */);

    /* Free storage for an address map */

void _c2_FreeAddrMap(/* _c2_AddrMap *m */);

    /* Make a UC node */

_c2_NodeBase *_c2_MakeNode( /* int UID, _c2_Index *Index,
			       _c2_GraphBase *Graph, void *LocalData,
			       void (*Comp)(), void (*Init)(),
			       int Crepped */ );
    /* Make NSRel node */

_c2_NSRelBase *_c2_MakeNSRel( /* int UID, _c2_Index *Index,
			         _c2_GraphBase *Graph, void *LocalData,
			         void (*Init)(), int Crepped */ );

    /* Make a graph */

_c2_GraphBase *_c2_MakeGraph(/* int UID, _c2_Index *Index,
                                 _c2_GraphBase *ParentGraph, 
				 void *LocalData */);


    /* Initialize nodes that have been waiting on creation params */

void _c2_InitWaitingNodes( /* _c2_GraphBase *g */ );


  /* Add NS lock to *sorted* list of locks */

void _c2_InsertLock( /* _c2_LockSet **HeadLock, _c2_LockSet *NewLock */ );

int _c2_GetAllLocks( /* _c2_NodeBase * _c2_na, _c2_LockSet **NextLock */ );
void _c2_RelAllLocks( /* _c2_LockSet **HeadLock, _c2_LockSet **NextLock */ );


 /* MakeObj is supplied by translation */

void *_c2_MakeObj(/* int UID, _c2_Index *Index, _c2_GraphBase *Graph
                     int *ObjType */);

#endif
