/* -*- C++ -*- */

#ifndef _ARRAY_H_
#define _ARRAY_H_

#include <assert.h>
#include <string.h>

template <class T>
class Array {
public:
  Array (int sz)
    : _size (sz),
      _data (new T[sz])
    {}

  ~Array (void) {
    delete _data;
  }

  Array (const Array& a)
    : _size (a._size),
      _data (new T[a._size])
  {
    memcpy (_data, a._data, sizeof(T) * _size);
  }

  const Array& operator= (const Array& a)
  {
    _size = a._size;
    delete [] _data;
    _data = new T[_size];
    memcpy (_data, a._data, sizeof(T) * _size);
  }


  T& operator[] (int i) {
    assert (i >= 0);
    assert (i < _size);
    return _data[i];
  }

  int size (void) { return _size; }

  operator T * (void) {
    return _data;
  }

private:
  int _size;
  T * _data;
};


#endif // _ARRAY_H_
