/*
  c2_addrmap.h
  ------------------------------------------------------------------------
  
  ------------------------------------------------------------------------
  @(#) $Id: c2_addrmap.h,v 1.13 1998/03/17 00:57:06 emery Exp $
  ------------------------------------------------------------------------
  AUTHOR/CONTACT:
 
  Emery Berger                    | <http://www.cs.utexas.edu/users/emery>
  Systems Analyst                 @           <mailto:emery@cs.utexas.edu>
  Parallel Programming Group      |  <http://www.cs.utexas.edu/users/code>
  Department of Computer Sciences |             <http://www.cs.utexas.edu>
  University of Texas at Austin   |                <http://www.utexas.edu>
  ========================================================================
*/

#ifndef _C2_ADDRMAP_H_
#define _C2_ADDRMAP_H_

#include "c2_forward.h"
#include "c2_misc.h"

class SerialMachine;

#ifdef __cplusplus
extern "C" {
#endif

  // Get address of UID from given graph.
  
  void *_c2_GetAddr (Graph *Graph,
		     int UID,
		     Index *Index,
		     SerialMachine * SerMach);


  // MakeObj is supplied by translation.

  extern void *_c2_MakeObj (int UID,
			    Index *Index,
			    Graph *Graph,
			    int *ObjType,
			    SerialMachine * SerMach);
  

#ifdef __cplusplus
}
#endif

#endif // _C2_ADDRMAP_H_
