/*
  fsynch.h
  ------------------------------------------------------------------------
  Wrappers for POSIX synchronization variables.
  ------------------------------------------------------------------------
  @(#) $Id: fsynch.h,v 1.12 1999/05/10 21:15:49 emery Exp $
  ------------------------------------------------------------------------
  AUTHOR/CONTACT:
 
  Emery Berger                    | <http://www.cs.utexas.edu/users/emery>
  Systems Analyst                 @           <mailto:emery@cs.utexas.edu>
  Parallel Programming Group      |  <http://www.cs.utexas.edu/users/code>
  Department of Computer Sciences |             <http://www.cs.utexas.edu>
  University of Texas at Austin   |                <http://www.utexas.edu>
  ========================================================================
*/

#ifndef _fastsynch_x
#define _fastsynch_x

#include "fthread.h"

/* define lock routines */

typedef pthread_mutex_t Lock;
typedef pthread_cond_t Cond;

void ConditionInit (Cond *cond);
int ConditionTimedWait (Cond * cond, Lock * lock, int sec);

#define ConditionWait(c,m) pthread_cond_wait((c), (m))
#define ConditionBroadcast(c) pthread_cond_broadcast((c))
#define ConditionSignal(c) pthread_cond_signal((c))
#define ConditionDestroy(c) pthread_cond_destroy((c))

void LockInit (Lock *lock, ...);
#define LockAcquire(lock) pthread_mutex_lock((lock))
int LockTryAcquire (Lock * lock);
#define LockRelease(lock) pthread_mutex_unlock((lock))

#endif
