/*
  fthread.c
  ------------------------------------------------------------------------
  POSIX thread wrappers.
  ------------------------------------------------------------------------
  @(#) $Id: fthread.C,v 1.16 1999/09/01 17:57:49 emery Exp $
  ------------------------------------------------------------------------
  AUTHOR/CONTACT:
 
  Emery Berger                    | <http://www.cs.utexas.edu/users/emery>
  Parallel Programming Group      |  <http://www.cs.utexas.edu/users/code>
  Department of Computer Sciences |             <http://www.cs.utexas.edu>
  University of Texas at Austin   |                <http://www.utexas.edu>
  ========================================================================
*/

#include <stdlib.h>

#include "fthread.h"

#include <stdio.h>
#include <limits.h>

void BoundThread::start (void (*procedureToRun)(void *),
			 void *arg,
			 int priority)
{
#if __SVR4
  pthread_attr_setscope (&_attr, PTHREAD_SCOPE_SYSTEM); /* bound behavior */
#endif

  struct sched_param parms;
  parms.sched_priority = priority;
  pthread_attr_setschedparam (&_attr, &parms);
  int result = pthread_create (&_thread, &_attr, (void *(*)(void*))procedureToRun, (void *) arg);

  if (result) {
    printf("Error %d received.\n", result);
    exit(1);
  }
}


void Thread::start (void (*procedureToRun)(void *),
		    void *arg,
		    int priority)
{
  struct sched_param parms;
  parms.sched_priority = priority;
  pthread_attr_setschedparam (&_attr, &parms);
  int result = pthread_create (&_thread, &_attr, (void *(*)(void*))procedureToRun, (void *) arg);

  if (result) {
    printf("Error %d received.\n", result);
    exit(1);
  }
}


void Thread::join (void) {
  void * result;
  pthread_join (_thread, &result);
}


pthread_t ThreadSelf (void) {
  return pthread_self ();
}


void Thread::cancel (void) {
  pthread_cancel (_thread);
}
