/*
  parms.H
  ------------------------------------------------------------------------
  Parameters for the CODE runtime system.
  ------------------------------------------------------------------------
  @(#) $Id: parms.H,v 1.10 1999/05/10 21:15:54 emery Exp $
  ------------------------------------------------------------------------
  AUTHOR/CONTACT:
 
  Emery Berger                    | <http://www.cs.utexas.edu/users/emery>
  Parallel Programming Group      |  <http://www.cs.utexas.edu/users/code>
  Department of Computer Sciences |             <http://www.cs.utexas.edu>
  University of Texas at Austin   |                <http://www.utexas.edu>
  ========================================================================
*/


#ifndef _PARMS_H_
#define _PARMS_H_


#define DENY_EXECUTION_OF_NONLOCAL_NODES 1
#define DEBUG_PRINT 0

#define THREAD_SAFE_MPI 0

#ifndef ALLOW_REMOTE_WORK_STEALING
#define ALLOW_REMOTE_WORK_STEALING 1  // 1 = default.
#endif

// Processor-mapping algorithms:
// exactly one of the below must be set to 1.

#ifndef ONE_PROCESSOR_PLACEMENT
#define ONE_PROCESSOR_PLACEMENT 0 	// = map to processor 0.
#endif
#ifndef PER_GRAPH_PLACEMENT
#define PER_GRAPH_PLACEMENT 0 		// = map to graph.
#endif
#ifndef MAP_ACROSS_ALL
#define MAP_ACROSS_ALL 0		// = old-style placement (map node).
#endif
#ifndef MAP_NON_SHARED_ACROSS_ALL
#define MAP_NON_SHARED_ACROSS_ALL 1 	// Default (non-statics can be anywhere).
#endif

#if (ONE_PROCESSOR_PLACEMENT + PER_GRAPH_PLACEMENT + MAP_ACROSS_ALL + MAP_NON_SHARED_ACROSS_ALL) != 1
#error "Exactly one of the above defines must be 1."
#endif

// Should we map non-statics to this processor?

#if !(ALLOW_REMOTE_WORK_STEALING)
#define MAP_NONSTATIC_LOCALLY 0
#else
#define MAP_NONSTATIC_LOCALLY 1 // 1 = Default.
#endif

#endif // _PARMS_H_
