/*
  unique.H
  ------------------------------------------------------------------------
  Any object that inherits from this class
  cannot be copied or assigned to or from.
  ------------------------------------------------------------------------
  @(#) $Id: unique.H,v 1.4 1998/04/07 04:48:28 emery Exp $
  ------------------------------------------------------------------------
  AUTHOR/CONTACT:
 
  Emery Berger                    | <http://www.cs.utexas.edu/users/emery>
  Parallel Programming Group      |  <http://www.cs.utexas.edu/users/code>
  Department of Computer Sciences |             <http://www.cs.utexas.edu>
  University of Texas at Austin   |                <http://www.utexas.edu>
  ========================================================================
*/


#ifndef _UNIQUE_H_
#define _UNIQUE_H_

// Any object that inherits from this class
// cannot be copied or assigned to or from.

// example usage:
//   class Foo : private Unique { ... };

class Unique {
public:
  Unique (void) { }
private:

  // Prevents copying and assignment.

  Unique (const Unique&);
  const Unique& operator= (const Unique&);
};

#endif
